/*
 * Input
 *
 * Index
 * - Input
 * - Textarea
 * - Label
 * - Sizes
 * - Error
 * - Helper
 */

/**
 * @prop --border-radius: Border radius of the field
 * @prop --height: height of the field
 * @prop --input-text-align: align the content of the field
 * @prop --margin-bottom: Bottom margin of the field
 */


:host {
  --height: 3rem;
  --border-radius: 0.25rem;
  --input-text-align: left;
  --margin-bottom: 1rem;

  position: relative;
  display: block;
  margin-bottom: var(--margin-bottom);
  font-family: var(--road-font, sans-serif);
  color: var(--road-grey-10);
}

/* INPUT
 -------------------- */

.form-control {
  box-sizing: border-box;
  display: block;
  width: 100%;
  height: var(--height);
  padding: 0.75rem 1rem 0;
  margin: 0;
  font-size: var(--road-body-medium);
  color: var(--road-on-surface);
  text-align: var(--input-text-align);
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: var(--border-radius);
  box-shadow: none;
  appearance: none;
}

/**
 * Remove native arrow on type number
 */

.form-control[type="number"] {
  appearance: textfield;
}

/**
 * Fix position of chrome native icon on type date and time
 */

.form-control::-webkit-calendar-picker-indicator {
  margin-top: -0.75rem;
}

/**
 * Fix position of iOS date and time value
 */

.form-control::-webkit-date-and-time-value {
  padding-top: 0.625rem;
}

/**
 * Placeholder
 */

.form-control::placeholder {
  color: var(--road-on-surface-extra-weak);
  opacity: 1;
}

/**
 * Hover state
 */

@media (hover: hover) {

  .form-control:not(:disabled):hover {
    border-color: var(--road-input-outline-variant);
  }
}

/**
 * Focus state
 */

.form-control:focus ~ .form-label,
.form-control[required]:valid ~ .form-label,
.form-control.has-value ~ .form-label,
.form-control[type="date"] ~ .form-label,
.form-control[type="time"] ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}

.form-control:placeholder-shown ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}

/* stylelint-disable */

/* IE FIX */

.form-control:-ms-input-placeholder ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}
/* stylelint-enable */

.form-control:not(:disabled):focus,
.form-control[autofocus],
.form-control:focus-visible{
  border-color: var(--road-input-outline-variant);
}

/**
 * Disabled state
 */

.form-control:disabled,
.form-control[readonly] {
  color: var(--road-on-surface-disabled);
  cursor: not-allowed;
  background: var(--road-surface-disabled);
  opacity: 1;
}

/* LABEL
 -------------------- */

.form-label {
  position: absolute;
  top: 0.75rem;
  left: 1rem;
  display: block;
  font-size: var(--road-body-medium);
  line-height: 1.5;
  color: var(--road-on-surface-weak);
  pointer-events: none;
  transition: transform 200ms cubic-bezier(0, 0, 0.2, 1) 0ms;
  transform-origin: 0 0;
}

.form-control:required ~ .form-label::after{
  color: var(--road-danger-default);
  content: " *";
}

:host:has([disabled]) .form-label{
  color: var(--road-on-surface-disabled);
}

/**
 * less label
 */

.less-label {
  padding-top: 0;
}

/* SIZES
 -------------------- */

:host(.input-xl) {
  --height: 3.5rem;
}

:host(.input-xl) .form-control {
  padding: 1rem 1rem 0;
}

:host(.phone-number) .form-control {
  padding-left: 2rem;
}

:host(.phone-number) .form-label {
  left: 2rem;
}

:host(.input-xl) .form-label {
  top: 1rem;
}

:host(.input-xl) .form-control:focus ~ .form-label,
:host(.input-xl) .form-control[autofocus] ~ .form-label,
:host(.input-xl) .form-control[required]:valid ~ .form-label,
:host(.input-xl) .form-control.has-value ~ .form-label,
:host(.input-xl) .form-control[type="date"] ~ .form-label,
:host(.input-xl) .form-control[type="time"] ~ .form-label {
  transform: scale(0.75) translateY(-0.625rem);
}

:host(.input-xl) .form-control:placeholder-shown ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}


/* ERROR
 -------------------- */

.invalid-feedback {
  display: none;
  width: 100%;
  margin-top: 0.5rem;
  font-size: var(--road-helper-medium);
  color: var(--road-on-danger-surface);
}

.invalid-feedback road-icon{
  color: var(--road-danger-icon);
  margin-right: var(--road-spacing-02);
}


.form-control.is-invalid,
.was-validated .form-control:invalid {
  border-color: var(--road-danger-outline);
}

.form-control.is-invalid ~ .invalid-feedback,
.was-validated .form-control:invalid ~ .invalid-feedback {
  display: flex;
}

/* HELPER
 -------------------- */

.helper {
  margin-top: 0.5rem;
  font-size: var(--road-body-small);
  color: var(--road-on-surface-weak);
}


/* PASSWORD
 -------------------- */

.form-control[type="password"] ~ .checklist-password .invalid{
  color: var(--road-on-surface-weak);
}
